GNU bug report logs - #58652
Creating home-emacs-service-type

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Zain Jabbar <zaijab2000@HIDDEN>; Keywords: patch moreinfo; merged with #58693; dated Thu, 20 Oct 2022 02:41:03 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.
Added tag(s) moreinfo. Request was from Christopher Baines <mail@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Merged 58652 58693. Request was from Liliana Marie Prikler <liliana.prikler@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 58652 <at> debbugs.gnu.org:


Received: (at 58652) by debbugs.gnu.org; 22 Oct 2022 07:09:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 22 03:09:54 2022
Received: from localhost ([127.0.0.1]:39616 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1om8dl-0001Bl-O9
	for submit <at> debbugs.gnu.org; Sat, 22 Oct 2022 03:09:54 -0400
Received: from mail-ed1-f45.google.com ([209.85.208.45]:42581)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zaijab2000@HIDDEN>) id 1om8di-0001BW-Tq
 for 58652 <at> debbugs.gnu.org; Sat, 22 Oct 2022 03:09:52 -0400
Received: by mail-ed1-f45.google.com with SMTP id u21so13511238edi.9
 for <58652 <at> debbugs.gnu.org>; Sat, 22 Oct 2022 00:09:50 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:from:to:cc:subject:date:message-id:reply-to;
 bh=b9JQvhEX+Xg1p2ahPNOzFpOn/KYkut3GyFvdPWgHNZg=;
 b=KzuEl2+/xgXu1GHpnvl8HwQOdtAKuOP4mHPoYHhizMYSyCaRmztbT9RvQVIgurBl1d
 pGQeiC/yLvWXhdMQFt5wlQWiCrAJp0xz0tzpLVQscIr/W8MCPsqm85BxQSdXuEbmXtFL
 Ebx9jzSHCFaivEfu4BH+8UHhKVaCXtFUitsRre6UFR9/BjX0b3UaYWIHRty4J+6AoM0z
 dehkSTKYjx17VqxrunSB4CpaJA+JzP46vxs62DrK/dxRLvQ8+dSJBFKo24iSg6LVD/7X
 Ju4C5FadvWnRgjlNx9E8FdPOjvejpwfCPviWuJC0W6f/s/nsZaDIR3ozTBDePvqTih5v
 meLQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date:message-id
 :reply-to;
 bh=b9JQvhEX+Xg1p2ahPNOzFpOn/KYkut3GyFvdPWgHNZg=;
 b=CquekbWilXscvp4cLhs/xxn4XHc0ET0NyqSzP7DdQ3NQRf9cMwQgc/0U5UBKPqhHtQ
 RjwnCWDfpfZFnhlTF4+l/JA52qsbW8JORytTQlJbw12V+ycjm7C6VBlZOMpMUFu013EQ
 Rk63hiqDXn/wKZqpcbVjoQmk0AJgVvtJbN6uWmHxb097kVjIs1ayEMJBeO0G+qPKngbf
 Zi7w83KGR9QCa7VYkkxpDVk2tw4m8S52/Ly638brYMSyeEuJ67VCnqB8zNyB+4Mgsoh4
 NsHOjFoXSCRWcrOBQlYNs535h4NKeNPAr4/yJRKmnIe7Cd/oXKElzNSAzpRfaMH0h9FH
 2X7w==
X-Gm-Message-State: ACrzQf3il7Alk73KaET/ICz5wLfLkBfSeA5QItKlWgaY31OGr45Vz28z
 x7jvOH4DaLIVXe6Sbp9d9gDe1zVRV4ZXyMIbEoc=
X-Google-Smtp-Source: AMsMyM7YJzN1Sxz4RhSmBABZdM7xBsUGGHzB+1fSM3+jl3h9mZlwQP78OZbfpXoFGs/pIhWC2BXTvrHujgDNsIS+hkQ=
X-Received: by 2002:a17:907:1c10:b0:791:a716:5089 with SMTP id
 nc16-20020a1709071c1000b00791a7165089mr15256274ejc.672.1666422584732; Sat, 22
 Oct 2022 00:09:44 -0700 (PDT)
MIME-Version: 1.0
References: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
 <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
 <CAH+UbWSRquXwawF80ghL36sf91Zp4rxKTdEXLoVFrq0pHLZVZw@HIDDEN>
 <77fbe7e648edfc15c8007616199a867dbae72b71.camel@HIDDEN>
In-Reply-To: <77fbe7e648edfc15c8007616199a867dbae72b71.camel@HIDDEN>
From: Zain Jabbar <zaijab2000@HIDDEN>
Date: Fri, 21 Oct 2022 21:09:33 -1000
Message-ID: <CAH+UbWRC5qOjsTnsanmkmRA0RQQwR_A-NNLes6kyvJ1EXrOKgg@HIDDEN>
Subject: Re: Creating home-emacs-service-type
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Content-Type: multipart/mixed; boundary="0000000000003599bc05eb9a3e91"
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 58652
Cc: 58652 <at> debbugs.gnu.org, jbranso@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.8 (/)

--0000000000003599bc05eb9a3e91
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Aloha All,

Apologies for the delay.

> Instead of 6+7, write a single commit and use =3Dgit format-patch=3D.

Understood. Used =3Dgit format-patch HEAD~1=3D after =3Dgit reset --hard
origin/HEAD=3D to only have a single commit.

> Is that #:splice? #t meant to be there?

Yes, I believe so. Without the =3D#:splice? #:t=3D everything within the
file is surrounded by parenthesis. For example

#+BEGIN_SRC scheme
(use-modules (gnu home services emacs)
     (gnu home)
     (guix gexp)
     (gnu packages)
     (ice-9 pretty-print)
     (gnu services))


(home-environment
 (services
  (list
   (service home-emacs-service-type
    (home-emacs-configuration
     (packages
      (list
       (specification->package "bash")
       (specification->package "emacs-next")))
     (extra-files (list (scheme-file "greetings" '((setq x 42) (setq y
10)) #:splice? #:t))))))))
#+END_SRC

Places =3D(setq x 42)(setq y 10)=3D (no whitespace so it's kind of hard to
read) in =3Dgreetings=3D. That would properly run as Elisp. Without the
splicing we obtain =3D((setq x 42) (setq y 10))=3D which assumes we will
call a function =3D(setq x 42)=3D on the argument =3D(setq y 10)=3D which w=
ill
not work.

> Also, why is bash required here?

Bash was there for debugging purposes. You are right though, it does
not make a lot of sense to be there. It should be in the
=3Dhome-environment=3D =3Dpackages=3D not in the =3Dhome-emacs-configuratio=
n=3D.
Surprisingly if =3Dbash=3D was not installed, =3Dsh=3D was nowhere to be fo=
und
from within =3Dguix home container ${FILE}=3D and Emacs info manuals were
not readable (something Joshua Branson helped me iron out).

> You should perhaps also distinguish
> the emacs package and the emacs-* packages like so:
> (emacs emacs-next)
> (packages (list emacs-dash emacs-tempel))

Attached is a patch with =3Demacs=3D as a configuration type and here is
an example =3Dhome-environment=3D where =3Dbash=3D installed using the
=3Dpackages=3D slot.

#+BEGIN_SRC scheme
(use-modules (gnu home services emacs)
     (gnu home)
     (guix gexp)
     (gnu packages)
     (ice-9 pretty-print)
     (gnu services))

(home-environment
 (packages (list (specification->package "bash")))
 (services
  (list
   (service home-emacs-service-type))))
#+END_SRC

In the guix-dev mailing list, it has been discussed that Andrew
Tropin's method of declaring a config is worthwhile inspiration. Here
is an example configuration block.

#+BEGIN_SRC scheme
(define emacs-configure-rde-keymaps
  (rde-emacs-configuration-package
   'rde-keymaps
   `((defvar rde-app-map nil "Prefix keymap for applications.")
     (define-prefix-command 'rde-app-map nil)
     (defvar rde-toggle-map nil "\
Prefix keymap for binding various minor modes for toggling functionalitty."=
)
     (define-prefix-command 'rde-toggle-map nil))
   #:summary "Keymaps inteded for reuse among configure-* packages"))
#+END_SRC

This is a bit closer to the current patch using S-Expressions over
files. Perhaps I should wait for more people to chime in. Maybe I can
try to please both sides. Make a conditional, if the =3Dinit=3D or
=3Dearly-init=3D form is empty (as it is by default) then allow for a file
named =3Dinit.el=3D in the =3Dextra-files=3D argument.

On Thu, Oct 20, 2022 at 8:06 PM Liliana Marie Prikler
<liliana.prikler@HIDDEN> wrote:
>
> Am Donnerstag, dem 20.10.2022 um 11:30 -1000 schrieb Zain Jabbar:
> > Aloha All,
> >
> > Thank you for your input.
> >
> > > Note that you reverted the patch direction.
> >
> > Please forgive me for that. Is it possible to explain what I did
> > wrong? I will outline my steps to help you figure out what I did
> > incorrectly.
> >
> > 1. I cloned the repo
> > 2. Used =3Dguix shell -D guix=3D
> > 3. Ran =3D./bootstrap=3D
> > 4. Ran =3D./configure --localstatedir=3D/var=3D
> > 5. Ran =3Dmake && make check=3D. By the way, my =3Dmake check=3D had a =
failed
> > test, I don't know if that was expected.
> > 6. Made some commits
> > 7. I used =3Dgit diff HEAD origin/HEAD > my-guix-patch.patch=3D.
> >
> > I might have messed around too much in my cloned repo, throwing
> > something off.
> Instead of 6+7, write a single commit and use =3Dgit format-patch=3D.
>
> You can of course do multi-patch series, but this feature seems not to
> be one that requires that.  Always clean up your commit log after a
> hacking session ;)
>
> > > You should also take an extra-files argument, e.g. to add custom.el
> > > or other elisp files that init.el might refer to.
> >
> > Understood. Attached as a new patch. =3Dhome-emacs-configuration=3D now
> > has an extra field =3Dextra-files=3D. To use it, input a list of file
> > objects. The service will splice them into
> > =3D$XDG_CONFIG_HOME/emacs/{FILE}=3D. Here is an example configuration.
> > Using =3Dguix home container=3D will allow you to see the file
> > =3Dgreetings=3D
> > with contents "hello world" in =3D.config/emacs/=3D.
> >
> > #+BEGIN_SRC scheme
> > (use-modules (gnu home services emacs)
> >      (gnu home)
> >      (guix gexp)
> >      (gnu packages)
> >      (ice-9 pretty-print)
> >      (gnu services))
> >
> > (home-environment
> >  (services
> >   (list
> >    (service home-emacs-service-type
> >     (home-emacs-configuration
> >      (packages
> >       (list
> >        (specification->package "bash")
> >        (specification->package "emacs-next")))
> >      (extra-files (list (scheme-file "greetings" '(hello world)
> > #:splice? #:t))))))))
> > #+END_SRC
> Is that #:splice? #t meant to be there?
>
> Also, why is bash required here?  You should perhaps also distinguish
> the emacs package and the emacs-* packages like so:
>
> (emacs emacs-next)
> (packages (list emacs-dash emacs-tempel))
>
> As a future extension, it'd be nice if we could use this service to
> easily specify native compilation for emacs packages, but for this one
> would have to lay some groundwork in emacs-build-system.
>
> > > Also, I'm not certain if "scheme-file" is the right primitive here
> > > =E2=80=93 Emacs Lisp does differ from Scheme, e.g. in keyword syntax =
among
> > > others.
> >
> > I agree; using =3Dscheme-file=3D for =3Demacs-lisp=3D feels blasphemous=
.
> > There are some odd errors associated with this method too. For
> > example, =3D#'foo=3D is the shorthand for =3D(function foo)=3D in Emacs=
 Lisp
> > but gets turned into =3D(syntax foo)=3D when using Guile. Meaning a pur=
e
> > drag and drop =3Dinit.el >> guile-sexp=3D has some things that need to =
be
> > changed.
> > The fact that Emacs-Lisp and Guile Scheme use S-Expressions was
> > something I wanted to leverage. It becomes easy to write Elisp in the
> > parens of the =3Dinit=3D parameter because there is no context switchin=
g
> > (e.g. lispy works, cape-symbols works for Elisp in Scheme).
> Note that Guile has an elisp reader, albeit a broken one, but no means
> to switch languages inside files.
>
> > I am open to other forms of inputting the text in the files. This is
> > a bit high maka maka, but I would also like to see how "elegant" the
> > other methods of inserting Elisp look. That is, can we make it
> > desirable for people to integrate Elisp into Guile Scheme moreso than
> > a =3Dlocal-file=3D declaration. Using backquotes and S-Expressions allo=
ws
> > for some variables from Guile to be placed into the Emacs
> > configuration like the system type, user names, and emails.
> I think taking a list of file-like objects and concatenating their
> contents might be worth considering.  That's a bit more overhead, but
> we'd have a cleaner separation between fragments that have the same
> semantics in Scheme and those that don't.
>
> Cheers



--=20
Mahalo,
Zain Jabbar

--0000000000003599bc05eb9a3e91
Content-Type: text/x-patch; charset="UTF-8"; 
	name="0001-Adding-home-emacs-service-type-and-home-emacs-config.patch"
Content-Disposition: attachment; 
	filename="0001-Adding-home-emacs-service-type-and-home-emacs-config.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_l9jkkpdi0>
X-Attachment-Id: f_l9jkkpdi0
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--0000000000003599bc05eb9a3e91--




Information forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.

Message received at 58652 <at> debbugs.gnu.org:


Received: (at 58652) by debbugs.gnu.org; 21 Oct 2022 15:42:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 11:42:39 2022
Received: from localhost ([127.0.0.1]:38749 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oluAQ-0006ob-Tj
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 11:42:39 -0400
Received: from mx1.dismail.de ([78.46.223.134]:13827)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <jbranso@HIDDEN>) id 1oluAO-0006oL-3E
 for 58652 <at> debbugs.gnu.org; Fri, 21 Oct 2022 11:42:37 -0400
Received: from mx1.dismail.de (localhost [127.0.0.1])
 by mx1.dismail.de (OpenSMTPD) with ESMTP id 785e4fc3;
 Fri, 21 Oct 2022 17:42:28 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed; d=dismail.de; h=from:to:cc
 :subject:in-reply-to:references:date:message-id:mime-version
 :content-type; s=20190914; bh=5c0osLW8j2edxcJuDCW44BNUdp84nXzFcP
 8JMhmhnCI=; b=oZ8A8uRefps0Yg+G66j6HtYlqE9V6IxoAXlrUZFCPZLbzh/NsF
 rN13t0cakl9c3D23JtWv2iNs6SNDRK+sW4gpB6yxxfeLRzVwRqn8GmGqCRLNbfC5
 Ma62CJC6F6YPx14EUckrjmuEMiN8POe3Q47g0943jORY9kv0HhkH3Q4dlvzdvLuO
 3mklOJL6XuYtEeMVOYzOzP7pMi3EJFjjAcxY0Wxeet1CRoTPzGgcIAy3Xf9XCPL4
 mnn6C0F+hp6utVjhHHSMzK3z7Vs1bKoDNrXiznnN85wvwJvhnEmlnw1cS1yN6dP9
 gAezCBu9pKQpceIzDFitfY8ueh2aBWh8k7Xg==
Received: from smtp1.dismail.de (<unknown> [10.240.26.11])
 by mx1.dismail.de (OpenSMTPD) with ESMTP id 24e4cf52;
 Fri, 21 Oct 2022 17:42:27 +0200 (CEST)
Received: from smtp1.dismail.de (localhost [127.0.0.1])
 by smtp1.dismail.de (OpenSMTPD) with ESMTP id 4d2b3aee;
 Fri, 21 Oct 2022 17:42:27 +0200 (CEST)
Received: by dismail.de (OpenSMTPD) with ESMTPSA id face3a0b
 (TLSv1.3:TLS_AES_256_GCM_SHA384:256:NO); 
 Fri, 21 Oct 2022 17:42:27 +0200 (CEST)
From: Joshua Branson <jbranso@HIDDEN>
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Subject: Re: Creating home-emacs-service-type
In-Reply-To: <77fbe7e648edfc15c8007616199a867dbae72b71.camel@HIDDEN>
 (Liliana Marie Prikler's message of "Fri, 21 Oct 2022 08:05:53 +0200")
References: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
 <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
 <CAH+UbWSRquXwawF80ghL36sf91Zp4rxKTdEXLoVFrq0pHLZVZw@HIDDEN>
 <77fbe7e648edfc15c8007616199a867dbae72b71.camel@HIDDEN>
X-Gnus-Sucks: I know man
Date: Fri, 21 Oct 2022 11:42:23 -0400
Message-ID: <87o7u55gkg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 58652
Cc: 58652 <at> debbugs.gnu.org, Zain Jabbar <zaijab2000@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Liliana Marie Prikler <liliana.prikler@HIDDEN> writes:

> Am Donnerstag, dem 20.10.2022 um 11:30 -1000 schrieb Zain Jabbar:
>> Aloha All,
>> 
>> Thank you for your input.
>> 
>> > Note that you reverted the patch direction.
>> 
>> Please forgive me for that. Is it possible to explain what I did
>> wrong? I will outline my steps to help you figure out what I did
>> incorrectly.
>> 
>> 1. I cloned the repo
>> 2. Used =guix shell -D guix=
>> 3. Ran =./bootstrap=
>> 4. Ran =./configure --localstatedir=/var=
>> 5. Ran =make && make check=. By the way, my =make check= had a failed
>> test, I don't know if that was expected.
>> 6. Made some commits
>> 7. I used =git diff HEAD origin/HEAD > my-guix-patch.patch=.
>> 
>> I might have messed around too much in my cloned repo, throwing
>> something off.
> Instead of 6+7, write a single commit and use =git format-patch=.
>
> You can of course do multi-patch series, but this feature seems not to
> be one that requires that.  Always clean up your commit log after a
> hacking session ;)

I personally find it really easy to use git send-email.  :)

Assuming you are in the guix git directory, then this command will send
the latest commit as a patch to the guix-patches email list.

#+BEGIN_SRC sh
git send-email --to='guix-patches@HIDDEN' \
--cc='efraim@HIDDEN' \
--subject-prefix='Patch staging '  --annotate  HEAD^
#+END_SRC

This website will walk you through setting up git send email.

https://git-send-email.io/




Information forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.

Message received at 58652 <at> debbugs.gnu.org:


Received: (at 58652) by debbugs.gnu.org; 21 Oct 2022 06:06:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 21 02:06:15 2022
Received: from localhost ([127.0.0.1]:36692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ollAd-0003UG-6O
	for submit <at> debbugs.gnu.org; Fri, 21 Oct 2022 02:06:15 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:33968)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1ollAa-0003U6-2m
 for 58652 <at> debbugs.gnu.org; Fri, 21 Oct 2022 02:06:13 -0400
Received: from lprikler-laptop.ist.intra (gw.ist.tugraz.at [129.27.202.101])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4Mtv950VY3z3wcG;
 Fri, 21 Oct 2022 08:06:00 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1666332361;
 bh=Gom0XkNQMU0mllhFn4VGsd/UiY/giakJNjJsCYpXV58=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References;
 b=nSS58hxoM0Gf77UQnnCDAA6j+/qB5fI0g5LqHtUETFKybwxp+UbarU+ylpSl9yTVi
 hrubgdQmYJf+yKsTrVkQWzY8lWp0P7RpEt5mBdCNyUAZLenzlX9mAhzH0rvIc76leL
 jcHKFH9xUEIO9GHJVb+fP4rmrGr07S3s6Qe0kVCA=
Message-ID: <77fbe7e648edfc15c8007616199a867dbae72b71.camel@HIDDEN>
Subject: Re: Creating home-emacs-service-type
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Zain Jabbar <zaijab2000@HIDDEN>
Date: Fri, 21 Oct 2022 08:05:53 +0200
In-Reply-To: <CAH+UbWSRquXwawF80ghL36sf91Zp4rxKTdEXLoVFrq0pHLZVZw@HIDDEN>
References: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
 <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
 <CAH+UbWSRquXwawF80ghL36sf91Zp4rxKTdEXLoVFrq0pHLZVZw@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-TUG-Backscatter-control: waObeELIUl4ypBWmcn/8wQ
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.116
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 58652
Cc: 58652 <at> debbugs.gnu.org, jbranso@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Donnerstag, dem 20.10.2022 um 11:30 -1000 schrieb Zain Jabbar:
> Aloha All,
>=20
> Thank you for your input.
>=20
> > Note that you reverted the patch direction.
>=20
> Please forgive me for that. Is it possible to explain what I did
> wrong? I will outline my steps to help you figure out what I did
> incorrectly.
>=20
> 1. I cloned the repo
> 2. Used =3Dguix shell -D guix=3D
> 3. Ran =3D./bootstrap=3D
> 4. Ran =3D./configure --localstatedir=3D/var=3D
> 5. Ran =3Dmake && make check=3D. By the way, my =3Dmake check=3D had a fa=
iled
> test, I don't know if that was expected.
> 6. Made some commits
> 7. I used =3Dgit diff HEAD origin/HEAD > my-guix-patch.patch=3D.
>=20
> I might have messed around too much in my cloned repo, throwing
> something off.
Instead of 6+7, write a single commit and use =3Dgit format-patch=3D.

You can of course do multi-patch series, but this feature seems not to
be one that requires that.  Always clean up your commit log after a
hacking session ;)

> > You should also take an extra-files argument, e.g. to add custom.el
> > or other elisp files that init.el might refer to.
>=20
> Understood. Attached as a new patch. =3Dhome-emacs-configuration=3D now
> has an extra field =3Dextra-files=3D. To use it, input a list of file
> objects. The service will splice them into
> =3D$XDG_CONFIG_HOME/emacs/{FILE}=3D. Here is an example configuration.
> Using =3Dguix home container=3D will allow you to see the file
> =3Dgreetings=3D
> with contents "hello world" in =3D.config/emacs/=3D.
>=20
> #+BEGIN_SRC scheme
> (use-modules (gnu home services emacs)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu home)
> =C2=A0=C2=A0=C2=A0=C2=A0 (guix gexp)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu packages)
> =C2=A0=C2=A0=C2=A0=C2=A0 (ice-9 pretty-print)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu services))
>=20
> (home-environment
> =C2=A0(services
> =C2=A0 (list
> =C2=A0=C2=A0 (service home-emacs-service-type
> =C2=A0=C2=A0=C2=A0 (home-emacs-configuration
> =C2=A0=C2=A0=C2=A0=C2=A0 (packages
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (list
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (specification->package "bash")
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (specification->package "emacs-next"=
)))
> =C2=A0=C2=A0=C2=A0=C2=A0 (extra-files (list (scheme-file "greetings" '(he=
llo world)
> #:splice? #:t))))))))
> #+END_SRC
Is that #:splice? #t meant to be there?

Also, why is bash required here?  You should perhaps also distinguish
the emacs package and the emacs-* packages like so:

(emacs emacs-next)
(packages (list emacs-dash emacs-tempel))

As a future extension, it'd be nice if we could use this service to
easily specify native compilation for emacs packages, but for this one
would have to lay some groundwork in emacs-build-system.

> > Also, I'm not certain if "scheme-file" is the right primitive here
> > =E2=80=93 Emacs Lisp does differ from Scheme, e.g. in keyword syntax am=
ong
> > others.
>=20
> I agree; using =3Dscheme-file=3D for =3Demacs-lisp=3D feels blasphemous.
> There are some odd errors associated with this method too. For
> example, =3D#'foo=3D is the shorthand for =3D(function foo)=3D in Emacs L=
isp
> but gets turned into =3D(syntax foo)=3D when using Guile. Meaning a pure
> drag and drop =3Dinit.el >> guile-sexp=3D has some things that need to be
> changed.
> The fact that Emacs-Lisp and Guile Scheme use S-Expressions was
> something I wanted to leverage. It becomes easy to write Elisp in the
> parens of the =3Dinit=3D parameter because there is no context switching
> (e.g. lispy works, cape-symbols works for Elisp in Scheme).
Note that Guile has an elisp reader, albeit a broken one, but no means
to switch languages inside files.

> I am open to other forms of inputting the text in the files. This is
> a bit high maka maka, but I would also like to see how "elegant" the
> other methods of inserting Elisp look. That is, can we make it
> desirable for people to integrate Elisp into Guile Scheme moreso than
> a =3Dlocal-file=3D declaration. Using backquotes and S-Expressions allows
> for some variables from Guile to be placed into the Emacs
> configuration like the system type, user names, and emails.
I think taking a list of file-like objects and concatenating their
contents might be worth considering.  That's a bit more overhead, but
we'd have a cleaner separation between fragments that have the same
semantics in Scheme and those that don't.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.

Message received at 58652 <at> debbugs.gnu.org:


Received: (at 58652) by debbugs.gnu.org; 20 Oct 2022 21:30:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 20 17:30:56 2022
Received: from localhost ([127.0.0.1]:36280 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1old7v-0006dp-TL
	for submit <at> debbugs.gnu.org; Thu, 20 Oct 2022 17:30:56 -0400
Received: from mail-ed1-f51.google.com ([209.85.208.51]:40904)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zaijab2000@HIDDEN>) id 1old7t-0006db-Iq
 for 58652 <at> debbugs.gnu.org; Thu, 20 Oct 2022 17:30:54 -0400
Received: by mail-ed1-f51.google.com with SMTP id r14so1490432edc.7
 for <58652 <at> debbugs.gnu.org>; Thu, 20 Oct 2022 14:30:53 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:from:to:cc:subject:date:message-id:reply-to;
 bh=Mi+KHTZNunOryy5MTl8o1tAPgdhHJCZ6ZWpkz3SLqIs=;
 b=UwIryInEr+swUTBPgiRFm8ANK+LCHQE8KAsLgLuEqGSdomETXWNHdf6/1n1eaAgotT
 Tc6VS+fCC037wfXNJnNDjIyAGU5TPvEOvXMu5AqxCldiRAFMAN2d5VL5GBaemvlj4j+U
 rmMpJ9UwUOK1YS/j5gKOiWyigSoOmEbtk1EskikHmwUsMQ6g0Mhm0maUxUmPj7Nr1ARq
 IzTxduj6VVAlDdvB7+1FAt1P9dxFcLgOipjOZQSIIzG5kcHubCguFvbs/HDI5+CnCUoc
 DRzWFOM8BQgIUEmqVSaQiiLp0GCz+yXCyY59gIyuttS6JorTwJaDf5BOMa3mW+772d49
 Km4g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=cc:to:subject:message-id:date:from:in-reply-to:references
 :mime-version:x-gm-message-state:from:to:cc:subject:date:message-id
 :reply-to;
 bh=Mi+KHTZNunOryy5MTl8o1tAPgdhHJCZ6ZWpkz3SLqIs=;
 b=bjbWbve789Ew41Jexc0eYGkG91A1jIP6uZXcI+UT+WkaZf9AKvfck0+lk6CYjy/3u+
 0b00Njxh0zYqnfDL2TI3Q1lGvsVdaNmVCmkYl3V0g6F6bfFJXbeXDtC+4Om6tIwQ1ivO
 AB8rnvbSn/ZDgcEqMItJ+4ROzghUvVjboVA797Cf9gr8LBNteQK07LBa3Qg0Y3y3lBXU
 5T0ZUQ/VYn8EOYBrw/4lVUNMSkKjoWXjYsPaHZAErc22Z+/C3b2qhZp5GqX4E72eKAcJ
 TiNZW9KjLr0fYPVzv/I2SjheYEMDWBaF0FL2ZVq+pXMm3Qt/4DBjhJwmL8ZUWMdAuIV7
 wYiw==
X-Gm-Message-State: ACrzQf036GsHDq+0/NxP/U9lvcGEUXMYM7O1OH4H5FfGQqV6ob+EXwrp
 5K1lvxVbTH8YnPUq+3fCi/9rVABiywqPPw2sQVk=
X-Google-Smtp-Source: AMsMyM6gjwNMrSHRnQjzjL558/UAn+V3Dm1cvUAEIvWMGyhlSIVeB0iqWblyo+3SF743B4TlPs0n4m6tMrvOgNEvpgs=
X-Received: by 2002:a05:6402:298d:b0:451:5fc5:d423 with SMTP id
 eq13-20020a056402298d00b004515fc5d423mr13927453edb.102.1666301447602; Thu, 20
 Oct 2022 14:30:47 -0700 (PDT)
MIME-Version: 1.0
References: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
 <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
In-Reply-To: <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
From: Zain Jabbar <zaijab2000@HIDDEN>
Date: Thu, 20 Oct 2022 11:30:36 -1000
Message-ID: <CAH+UbWSRquXwawF80ghL36sf91Zp4rxKTdEXLoVFrq0pHLZVZw@HIDDEN>
Subject: Re: Creating home-emacs-service-type
To: Liliana Marie Prikler <liliana.prikler@HIDDEN>
Content-Type: multipart/mixed; boundary="000000000000dfa3d905eb7e0943"
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 58652
Cc: 58652 <at> debbugs.gnu.org, jbranso@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.8 (/)

--000000000000dfa3d905eb7e0943
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Aloha All,

Thank you for your input.

> Note that you reverted the patch direction.

Please forgive me for that. Is it possible to explain what I did
wrong? I will outline my steps to help you figure out what I did
incorrectly.

1. I cloned the repo
2. Used =3Dguix shell -D guix=3D
3. Ran =3D./bootstrap=3D
4. Ran =3D./configure --localstatedir=3D/var=3D
5. Ran =3Dmake && make check=3D. By the way, my =3Dmake check=3D had a fail=
ed
test, I don't know if that was expected.
6. Made some commits
7. I used =3Dgit diff HEAD origin/HEAD > my-guix-patch.patch=3D.

I might have messed around too much in my cloned repo, throwing something o=
ff.

> You should also take an extra-files argument, e.g. to add custom.el or
> other elisp files that init.el might refer to.

Understood. Attached as a new patch. =3Dhome-emacs-configuration=3D now
has an extra field =3Dextra-files=3D. To use it, input a list of file
objects. The service will splice them into
=3D$XDG_CONFIG_HOME/emacs/{FILE}=3D. Here is an example configuration.
Using =3Dguix home container=3D will allow you to see the file =3Dgreetings=
=3D
with contents "hello world" in =3D.config/emacs/=3D.

#+BEGIN_SRC scheme
(use-modules (gnu home services emacs)
     (gnu home)
     (guix gexp)
     (gnu packages)
     (ice-9 pretty-print)
     (gnu services))

(home-environment
 (services
  (list
   (service home-emacs-service-type
    (home-emacs-configuration
     (packages
      (list
       (specification->package "bash")
       (specification->package "emacs-next")))
     (extra-files (list (scheme-file "greetings" '(hello world)
#:splice? #:t))))))))
#+END_SRC

> Also, I'm not certain if "scheme-file" is the right primitive here =E2=80=
=93
> Emacs Lisp does differ from Scheme, e.g. in keyword syntax among
> others.

I agree; using =3Dscheme-file=3D for =3Demacs-lisp=3D feels blasphemous. Th=
ere
are some odd errors associated with this method too. For example,
=3D#'foo=3D is the shorthand for =3D(function foo)=3D in Emacs Lisp but get=
s
turned into =3D(syntax foo)=3D when using Guile. Meaning a pure drag and
drop =3Dinit.el >> guile-sexp=3D has some things that need to be changed.
The fact that Emacs-Lisp and Guile Scheme use S-Expressions was
something I wanted to leverage. It becomes easy to write Elisp in the
parens of the =3Dinit=3D parameter because there is no context switching
(e.g. lispy works, cape-symbols works for Elisp in Scheme).

I am open to other forms of inputting the text in the files. This is a
bit high maka maka, but I would also like to see how "elegant" the
other methods of inserting Elisp look. That is, can we make it
desirable for people to integrate Elisp into Guile Scheme moreso than
a =3Dlocal-file=3D declaration. Using backquotes and S-Expressions allows
for some variables from Guile to be placed into the Emacs
configuration like the system type, user names, and emails.

On Thu, Oct 20, 2022 at 2:54 AM Liliana Marie Prikler
<liliana.prikler@HIDDEN> wrote:
>
> Am Mittwoch, dem 19.10.2022 um 15:59 -1000 schrieb Zain Jabbar:
> > Aloha Guix Development Team,
> >
> > First submission of a patch to this mail service. Hopefully this
> > works. I welcome any and all feedback.
> >
> > Attached is a patch which creates a new file
> > =3D/gnu/home/services/emacs.scm=3D which defines a new service
> > =3Dhome-emacs-service-type=3D and a configuration for said service
> > =3Dhome-emacs-configuration=3D. The configuration contains a list of
> > packages to add to the home-profile, and a list of expressions to add
> > into Emacs' =3Dinit.el=3D and =3Dearly-init.el=3D.
> Note that you reverted the patch direction.
>
> > Here is an example of a home environment file which:
> >
> > Adds the following packages:
> > - =3Dbash=3D
> > - =3Demacs-next=3D
> > - =3Demacs-debbugs=3D
> > - =3Demacs-evil=3D
> > - =3Demacs-paredit=3D
> > - =3Demacs-anzu=3D
> >
> > Overwrites the =3D.config/emacs/init.el=3D with:
> > #+BEGIN_SRC emacs-lisp
> > (evil-mode 1)
> > #+END_SRC
> >
> > Overwrites the =3D.config/emacs/early-init.el=3D with:
> > #+BEGIN_SRC emacs-lisp
> > (setq warning-suppress-log-types '((comp) (comp))) (setq
> > warning-suppress-types '((comp) (comp)))
> > #+END_SRC
> >
> > #+BEGIN_SRC scheme
> > (use-modules (gnu home services emacs)
> >      (gnu home)
> >      (gnu packages)
> >      (ice-9 pretty-print)
> >      (gnu services))
> >
> > (define-public minimal-home-environment
> >   (home-environment
> >    (services
> >     (list
> >      (service home-emacs-service-type
> >       (home-emacs-configuration
> >        (packages
> > (list
> > (specification->package "bash")
> > (specification->package "emacs-next")
> > (specification->package "emacs-debbugs")
> > (specification->package "emacs-evil")
> > (specification->package "emacs-paredit")
> > (specification->package "emacs-anzu")))
> >        (init '((evil-mode 1)))
> >        (early-init '((setq warning-suppress-log-types '((comp)
> > (comp)))
> >      (setq warning-suppress-types '((comp) (comp)))))))))))
> >
> > minimal-home-environment
> > #+END_SRC
> You should also take an extra-files argument, e.g. to add custom.el or
> other elisp files that init.el might refer to.
>
> Also, I'm not certain if "scheme-file" is the right primitve here =E2=80=
=93
> Emacs Lisp does differ from Scheme, e.g. in keyword syntax among
> others.
>
> Cheers



--
Mahalo,
Zain Jabbar

--000000000000dfa3d905eb7e0943
Content-Type: application/x-patch; 
	name="home-emacs-service-type-extra-files.patch"
Content-Disposition: attachment; 
	filename="home-emacs-service-type-extra-files.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_l9hk80vh0>
X-Attachment-Id: f_l9hk80vh0
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--000000000000dfa3d905eb7e0943--




Information forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.

Message received at 58652 <at> debbugs.gnu.org:


Received: (at 58652) by debbugs.gnu.org; 20 Oct 2022 12:54:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 20 08:54:07 2022
Received: from localhost ([127.0.0.1]:33353 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olV3n-0003Li-AN
	for submit <at> debbugs.gnu.org; Thu, 20 Oct 2022 08:54:07 -0400
Received: from mailrelay.tugraz.at ([129.27.2.202]:49671)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <liliana.prikler@HIDDEN>) id 1olV3l-0003LZ-1t
 for 58652 <at> debbugs.gnu.org; Thu, 20 Oct 2022 08:54:06 -0400
Received: from lprikler-laptop.ist.intra (gw.ist.tugraz.at [129.27.202.101])
 by mailrelay.tugraz.at (Postfix) with ESMTPSA id 4MtSGH6lpfz3wcZ;
 Thu, 20 Oct 2022 14:53:59 +0200 (CEST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tugraz.at;
 s=mailrelay; t=1666270440;
 bh=j2ByuQxUAMK3LBysKxFphkxpw5GmT4Qytm1dlJIUQ7Q=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=ovhsT/uOHiX+K7t9DXRECO56Rp0ThWc5nWwmDgvHGbzIz8mBzCdY8G3Jh3RFR8Vcy
 X5RDtKmGyXinFipkmNgMv7usUBhUZZgRZh5Bxed5p6yBCMEfbgvi2Yoe4PuUIsRAyP
 q9crCBFtmAvc29Vy3YDecnH9Urrh2EMP8HS3Shic=
Message-ID: <495a0fab9b20dd40f9fb1aef2261b60e053bf5cd.camel@HIDDEN>
Subject: Re: Creating home-emacs-service-type
From: Liliana Marie Prikler <liliana.prikler@HIDDEN>
To: Zain Jabbar <zaijab2000@HIDDEN>, 58652 <at> debbugs.gnu.org, 
 jbranso@HIDDEN
Date: Thu, 20 Oct 2022 14:53:58 +0200
In-Reply-To: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
References: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
User-Agent: Evolution 3.46.0 
MIME-Version: 1.0
X-TUG-Backscatter-control: waObeELIUl4ypBWmcn/8wQ
X-Spam-Scanner: SpamAssassin 3.003001 
X-Spam-Score-relay: -1.9
X-Scanned-By: MIMEDefang 2.74 on 129.27.10.116
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 58652
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Am Mittwoch, dem 19.10.2022 um 15:59 -1000 schrieb Zain Jabbar:
> Aloha Guix Development Team,
>=20
> First submission of a patch to this mail service. Hopefully this
> works. I welcome any and all feedback.
>=20
> Attached is a patch which creates a new file
> =3D/gnu/home/services/emacs.scm=3D which defines a new service
> =3Dhome-emacs-service-type=3D and a configuration for said service
> =3Dhome-emacs-configuration=3D. The configuration contains a list of
> packages to add to the home-profile, and a list of expressions to add
> into Emacs' =3Dinit.el=3D and =3Dearly-init.el=3D.
Note that you reverted the patch direction.

> Here is an example of a home environment file which:
>=20
> Adds the following packages:
> - =3Dbash=3D
> - =3Demacs-next=3D
> - =3Demacs-debbugs=3D
> - =3Demacs-evil=3D
> - =3Demacs-paredit=3D
> - =3Demacs-anzu=3D
>=20
> Overwrites the =3D.config/emacs/init.el=3D with:
> #+BEGIN_SRC emacs-lisp
> (evil-mode 1)
> #+END_SRC
>=20
> Overwrites the =3D.config/emacs/early-init.el=3D with:
> #+BEGIN_SRC emacs-lisp
> (setq warning-suppress-log-types '((comp) (comp))) (setq
> warning-suppress-types '((comp) (comp)))
> #+END_SRC
>=20
> #+BEGIN_SRC scheme
> (use-modules (gnu home services emacs)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu home)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu packages)
> =C2=A0=C2=A0=C2=A0=C2=A0 (ice-9 pretty-print)
> =C2=A0=C2=A0=C2=A0=C2=A0 (gnu services))
>=20
> (define-public minimal-home-environment
> =C2=A0 (home-environment
> =C2=A0=C2=A0 (services
> =C2=A0=C2=A0=C2=A0 (list
> =C2=A0=C2=A0=C2=A0=C2=A0 (service home-emacs-service-type
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (home-emacs-configuration
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (packages
> (list
> (specification->package "bash")
> (specification->package "emacs-next")
> (specification->package "emacs-debbugs")
> (specification->package "emacs-evil")
> (specification->package "emacs-paredit")
> (specification->package "emacs-anzu")))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (init '((evil-mode 1)))
> =C2=A0=C2=A0=C2=A0=C2=A0=C2=A0=C2=A0 (early-init '((setq warning-suppress=
-log-types '((comp)
> (comp)))
> =C2=A0=C2=A0=C2=A0=C2=A0 (setq warning-suppress-types '((comp) (comp)))))=
))))))
>=20
> minimal-home-environment
> #+END_SRC
You should also take an extra-files argument, e.g. to add custom.el or
other elisp files that init.el might refer to.

Also, I'm not certain if "scheme-file" is the right primitve here =E2=80=93
Emacs Lisp does differ from Scheme, e.g. in keyword syntax among
others.

Cheers




Information forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Oct 2022 02:40:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 19 22:40:40 2022
Received: from localhost ([127.0.0.1]:60746 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1olLU7-0005BY-VV
	for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 22:40:40 -0400
Received: from lists.gnu.org ([209.51.188.17]:51884)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zaijab2000@HIDDEN>) id 1olKqF-000496-VZ
 for submit <at> debbugs.gnu.org; Wed, 19 Oct 2022 21:59:28 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:43256)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <zaijab2000@HIDDEN>)
 id 1olKqF-0000Ar-OL
 for guix-patches@HIDDEN; Wed, 19 Oct 2022 21:59:27 -0400
Received: from mail-ej1-x630.google.com ([2a00:1450:4864:20::630]:45596)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <zaijab2000@HIDDEN>)
 id 1olKqD-00015g-MR
 for guix-patches@HIDDEN; Wed, 19 Oct 2022 21:59:27 -0400
Received: by mail-ej1-x630.google.com with SMTP id sc25so44017263ejc.12
 for <guix-patches@HIDDEN>; Wed, 19 Oct 2022 18:59:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=to:subject:message-id:date:from:mime-version:from:to:cc:subject
 :date:message-id:reply-to;
 bh=qiWfhCTnU5Lul75gz2L3HqqLuY5aHvj6dy1/ALt/Nlg=;
 b=EkXE3wu0zcE1A2Ukzykc2i6RhSW/ixourzn5qKlAu5cXWpT93eFRJ/QhzKvAcXBhiU
 HruOA0W7UausIkL9ADkfrgYGNUWjQAupioX6WQfDwQwatxFPRNC0xizNj04eWH6MAUwA
 rEwxNhOQkG4LCM8gTVYeEvPM9bLxgxEPVHKIivwkcif5r5XOrHnhy0cKJ9t6+oZKmg1R
 v9PBh/liUqJF6b6Wq2UF8tChwQVZgIX4709ip0iSfovueZyR7Wk0QAZsuFlwfV+34e8Y
 4vCe/bbPpKxOzuQzYz2jTPh73ltIVCEX5WGQGkqubHpH14JjjAjzd5xlYw2DN2yIrhYE
 0QDg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=to:subject:message-id:date:from:mime-version:x-gm-message-state
 :from:to:cc:subject:date:message-id:reply-to;
 bh=qiWfhCTnU5Lul75gz2L3HqqLuY5aHvj6dy1/ALt/Nlg=;
 b=YrHwiBbBQBhOXrWZfrckGeYrL/6ID3czU4s9c6fstuk2XmgqJ/q1Ned6R5J5kqEwGt
 6pStip3oTwwKRi5faSlyJGw10odLUO+nWCyKZlJNlwLub0qQqjdTz6Jjqy3jOyeJHVJh
 vFBSbitvQM2Zbbx7SSHxndR884bhDYT0s20fQY1WTbNCYjbOCrf09RtsFsmDpSioXbqS
 ak9TbZFsOGB9e9XucOVoYwWqhdVhzK84PALy4dlwHD5k8MLDliHkDnt/NnPqMClbLA/u
 q7HeG9JDfyTYnyudHSV6oG7IE/NyA7o4Ao9C44n/kir2IlVfqv0rvVHcPUZ1CBD5re8H
 UeoA==
X-Gm-Message-State: ACrzQf30WgC0go37DebUAQxd7SP8npQqcDl0+1IVNernHPLfw4qGTRYd
 ZGDMmZ+ulusX+lluTwO1t61jcR3TquYuGgSOgpTQ+wtdlSs=
X-Google-Smtp-Source: AMsMyM5FQL9QuYIPqRPp44dEJwVIFVobmgEAZZzXfGKGc2+/J70/ZuAPueTAD/wRpMDmURZlFjZfvLvTqKQ3Cd99DXU=
X-Received: by 2002:a17:907:1c10:b0:791:a716:5089 with SMTP id
 nc16-20020a1709071c1000b00791a7165089mr5279870ejc.672.1666231163616; Wed, 19
 Oct 2022 18:59:23 -0700 (PDT)
MIME-Version: 1.0
From: Zain Jabbar <zaijab2000@HIDDEN>
Date: Wed, 19 Oct 2022 15:59:12 -1000
Message-ID: <CAH+UbWQRoqsgSWpFyb5xjvGsepp0mG86W6g_a4SU04yHFc_mgw@HIDDEN>
Subject: Creating home-emacs-service-type
To: guix-patches@HIDDEN, jbranso@HIDDEN
Content-Type: multipart/mixed; boundary="0000000000009f19aa05eb6dacba"
Received-SPF: pass client-ip=2a00:1450:4864:20::630;
 envelope-from=zaijab2000@HIDDEN; helo=mail-ej1-x630.google.com
X-Spam_score_int: -17
X-Spam_score: -1.8
X-Spam_bar: -
X-Spam_report: (-1.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 FREEMAIL_ENVFROM_END_DIGIT=0.25, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Wed, 19 Oct 2022 22:40:37 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

--0000000000009f19aa05eb6dacba
Content-Type: text/plain; charset="UTF-8"

Aloha Guix Development Team,

First submission of a patch to this mail service. Hopefully this
works. I welcome any and all feedback.

Attached is a patch which creates a new file
=/gnu/home/services/emacs.scm= which defines a new service
=home-emacs-service-type= and a configuration for said service
=home-emacs-configuration=. The configuration contains a list of
packages to add to the home-profile, and a list of expressions to add
into Emacs' =init.el= and =early-init.el=.

Here is an example of a home environment file which:

Adds the following packages:
- =bash=
- =emacs-next=
- =emacs-debbugs=
- =emacs-evil=
- =emacs-paredit=
- =emacs-anzu=

Overwrites the =.config/emacs/init.el= with:
#+BEGIN_SRC emacs-lisp
(evil-mode 1)
#+END_SRC

Overwrites the =.config/emacs/early-init.el= with:
#+BEGIN_SRC emacs-lisp
(setq warning-suppress-log-types '((comp) (comp))) (setq
warning-suppress-types '((comp) (comp)))
#+END_SRC

#+BEGIN_SRC scheme
(use-modules (gnu home services emacs)
     (gnu home)
     (gnu packages)
     (ice-9 pretty-print)
     (gnu services))

(define-public minimal-home-environment
  (home-environment
   (services
    (list
     (service home-emacs-service-type
      (home-emacs-configuration
       (packages
(list
(specification->package "bash")
(specification->package "emacs-next")
(specification->package "emacs-debbugs")
(specification->package "emacs-evil")
(specification->package "emacs-paredit")
(specification->package "emacs-anzu")))
       (init '((evil-mode 1)))
       (early-init '((setq warning-suppress-log-types '((comp) (comp)))
     (setq warning-suppress-types '((comp) (comp)))))))))))

minimal-home-environment
#+END_SRC

Saving this text into a file =minimal-working-example.scm= allows us
to run this configuration with =guix home -N --share=/tmp container
./minimal-working-example.scm=.

-- 
Mahalo,
Zain Jabbar

--0000000000009f19aa05eb6dacba
Content-Type: text/x-patch; charset="UTF-8"; name="home-emacs-service-type.patch"
Content-Disposition: attachment; filename="home-emacs-service-type.patch"
Content-Transfer-Encoding: base64
Content-ID: <f_l9gehcix0>
X-Attachment-Id: f_l9gehcix0
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--0000000000009f19aa05eb6dacba--




Acknowledgement sent to Zain Jabbar <zaijab2000@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#58652; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 3 Nov 2022 16:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.